//------------------------------------------------------------
//  Convert WinMain() to main()
//    Reference from kenmo gamehell 2000
//    http://www5.atwiki.jp/yaruhara/pages/74.html
//------------------------------------------------------------

version (Windows) {

private import std.string;
private import std.c.windows.windows;

extern (C) void gc_init();
extern (C) void gc_term();
extern (C) void _minit();
extern (C) void _moduleCtor();
extern (C) void _moduleDtor();

// User defined main()
int main(char[][] args);

extern (Windows) 
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    int result = 0;

    // Initialize something
    gc_init();
    _minit();

    try
    {
        _moduleCtor();

        // Get module name
        char exe_name[4096];
        GetModuleFileNameA(null, exe_name.ptr, 4096);
        
        // Convert to char[][] arg
        char[]    str_arg = std.string.toString(exe_name.ptr) ~ " " ~ std.string.toString(lpCmdLine);
        char[][]  arg     = std.string.split(str_arg);

        // Call main()
        result = main(arg);
        
        _moduleDtor();
    }

    catch (Object o)
    {
        // Catch spilled exception
        MessageBoxA(null, cast(char *)o.toString(), "Error", MB_OK | MB_ICONEXCLAMATION);
        result = 0;
    }

    // Terminate something
    gc_term();
    
    return result;
}

}
